//TIMx constant file
#ifndef TIM_H
#define TIM_H

#include "HDL51001_ccf.h"
#include "HDL50001_gpio.h"

typedef struct
{
  __IO uint32_t PSCVAL;
  __IO uint32_t PSCPER;
  __IO uint32_t RESERVED0;
  __IO uint32_t RESERVED1;
  __IO uint32_t CNTVAL;
  __IO uint32_t CNT;
  __IO uint32_t CR;
  
} TIM_TypeDef;

#define APB0PERIPH_BASE       (0xC0000000)
#define APB1PERIPH_BASE       (0xC0100000)
//Timer 0
#define TIM0_BASE            (APB0PERIPH_BASE + 0x00010000)
#define TIM0		         ((TIM_TypeDef *) TIM0_BASE)

//Timer 1
#define TIM1_BASE            (APB0PERIPH_BASE + 0x00010100)
#define TIM1		         ((TIM_TypeDef *) TIM1_BASE)

//Timer 2
#define TIM2_BASE            (APB0PERIPH_BASE + 0x00010200)
#define TIM2		         ((TIM_TypeDef *) TIM2_BASE)

//Timer 3
#define TIM3_BASE            (APB1PERIPH_BASE + 0x00110000)
#define TIM3		         ((TIM_TypeDef *) TIM3_BASE)

//Timer 4
#define TIM4_BASE            (APB1PERIPH_BASE + 0x00110100)
#define TIM4		         ((TIM_TypeDef *) TIM4_BASE)

//Timer 5
#define TIM5_BASE            (APB1PERIPH_BASE + 0x00110200)
#define TIM5		         ((TIM_TypeDef *) TIM5_BASE)

//Timer 6
#define TIM6_BASE            (APB1PERIPH_BASE + 0x00110300)
#define TIM6		         ((TIM_TypeDef *) TIM6_BASE)


//timer constant and macro
//c  TIM (TIM0...TIM6) 
#define TIM_CR(EN, MODE, LOAD, IE, INT, TIM) TIM->CR = ((EN & 0x01)|((MODE & 0x01)<<1)|((LOAD & 0x01)<<2)|((IE & 0x01)<<3)|((INT & 0x01)<<4))
//   
#define TIM_PSCVAL(PSCVALUE, TIM) TIM->PSCVAL = PSCVALUE
//  
#define TIM_PSCPER(PSCPERIOD, TIM) TIM->PSCPER = PSCPERIOD
//   
#define TIM_CNTVAL(CNTVALUE, TIM) TIM->CNTVAL = CNTVALUE
//  
#define TIM_CNT(VALUE, TIM) TIM->CNT = VALUE
//    
#define TIM_CLEAR_INT(TIM) TIM->CNT |= 0x10 

#endif




























































